<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JPSOAP_DateIntervalsGroups StructType
 * @subpackage Structs
 */
class JPSOAP_DateIntervalsGroups extends AbstractStructBase
{
    /**
     * The Date
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_DateIntervals[]
     */
    public $Date;
    /**
     * Constructor method for JPSOAP_DateIntervalsGroups
     * @uses JPSOAP_DateIntervalsGroups::setDate()
     * @param \StructType\JPSOAP_DateIntervals[] $date
     */
    public function __construct(array $date = array())
    {
        $this
            ->setDate($date);
    }
    /**
     * Get Date value
     * @return \StructType\JPSOAP_DateIntervals[]|null
     */
    public function getDate()
    {
        return $this->Date;
    }
    /**
     * This method is responsible for validating the values passed to the setDate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDateForArrayConstraintsFromSetDate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $jPSOAP_DateIntervalsGroupsDateItem) {
            // validation for constraint: itemType
            if (!$jPSOAP_DateIntervalsGroupsDateItem instanceof \StructType\JPSOAP_DateIntervals) {
                $invalidValues[] = is_object($jPSOAP_DateIntervalsGroupsDateItem) ? get_class($jPSOAP_DateIntervalsGroupsDateItem) : sprintf('%s(%s)', gettype($jPSOAP_DateIntervalsGroupsDateItem), var_export($jPSOAP_DateIntervalsGroupsDateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Date property can only contain items of type \StructType\JPSOAP_DateIntervals, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_DateIntervals[] $date
     * @return \StructType\JPSOAP_DateIntervalsGroups
     */
    public function setDate(array $date = array())
    {
        // validation for constraint: array
        if ('' !== ($dateArrayErrorMessage = self::validateDateForArrayConstraintsFromSetDate($date))) {
            throw new \InvalidArgumentException($dateArrayErrorMessage, __LINE__);
        }
        $this->Date = $date;
        return $this;
    }
    /**
     * Add item to Date value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_DateIntervals $item
     * @return \StructType\JPSOAP_DateIntervalsGroups
     */
    public function addToDate(\StructType\JPSOAP_DateIntervals $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_DateIntervals) {
            throw new \InvalidArgumentException(sprintf('The Date property can only contain items of type \StructType\JPSOAP_DateIntervals, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Date[] = $item;
        return $this;
    }
}
